.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include mouseanimation.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG

	.elseif eax==WM_COMMAND
     invoke GetDC,NULL							;the whole screen is DC
	 mov hdc,eax
	 invoke SetTimer,hWin,1,10,NULL				;now we got 10fps
	 mov TIMER_ID,eax
	
	.elseif eax==WM_TIMER
	 cmp anzahl_timer,0							;if yes then create a new pixel
	 jnz @loc									;else just move all pixels
	 invoke CreateDot							
	 mov anzahl_timer,3							;every 30ms a new pixel is created (3*10)
	 mov pix_out_of_range,0
	 @loc:
	 invoke UpdateDot
	 dec anzahl_timer							;every 10ms all pixel are moved
	 
	
	.elseif eax==WM_CLOSE
	 invoke ReleaseDC,hWin,hdc
	 invoke EndDialog,hWin,0
	 invoke InvalidateRect,NULL,NULL,TRUE		;this will redraw all windows(because of the many drawing bugs still left in the programm):-)
	 invoke KillTimer,hWin,TIMER_ID
	
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

CreateDot proc uses eax ebx esi				;"Creating a new Pixel" procedure
LOCAL point:POINT

	cmp pix_out_of_range,0					;if a pixel has left the screen the new pixel..
	jz @loc1								;will be created at the memory location of the pixel that has left the screen
	 mov esi,pix_out_of_range
	 jmp @rest
	@loc1:
	 mov ebx,anzahl_pixel					;else write it to a new memory location
	 imul ebx, SIZEOF SINGLE_DOT		
	 mov esi,OFFSET dots
	 add esi,ebx
     inc anzahl_pixel
	@rest:
	invoke GetCursorPos,addr point
	push point.x
	push point.y
	pop [esi.SINGLE_DOT.position.y]			;the cursors position is written to the pixel structure
	pop [esi.SINGLE_DOT.position.x]
	invoke GetPixel,hdc,point.x,point.y		;the color of the screen is saved to the structure(we need that to erase our black pixel)
	mov [esi.SINGLE_DOT.pixcolor],eax
	mov [esi.SINGLE_DOT.velocity],1	
	ret
CreateDot endp

UpdateDot proc uses eax ebx esi					;Moving all Pixel" procedure
	xor ebx,ebx
	mov esi, OFFSET dots
	.REPEAT
	 invoke SetPixel,hdc,[esi.SINGLE_DOT.position.x],[esi.SINGLE_DOT.position.y],[esi.SINGLE_DOT.pixcolor];erasing our pixel
	 add [esi.SINGLE_DOT.velocity],2
	 mov eax,[esi.SINGLE_DOT.velocity]		;moving our pixel two pixel down
	 add eax,[esi.SINGLE_DOT.position.y]
	 mov [esi.SINGLE_DOT.position.y],eax
	 cmp [esi.SINGLE_DOT.position.y],769	;check if our pixel is out of screen(depends on screen resolution)
	 jl @loc2
	 mov pix_out_of_range,esi				;if yes then save memory location of the pixel that went out of the screen to pix_out_of_screen
	 @loc2:
	 invoke GetPixel,hdc,[esi.SINGLE_DOT.position.x],[esi.SINGLE_DOT.position.y];the color of the screen at the NEW position is saved to the structure(we need that to erase our black pixel)
	 mov [esi.SINGLE_DOT.pixcolor],eax
	 invoke SetPixel,hdc,[esi.SINGLE_DOT.position.x],[esi.SINGLE_DOT.position.y],0;draw the black pixel at its new position
	 add esi,SIZEOF SINGLE_DOT
	 inc ebx
	.UNTIL ebx==anzahl_pixel				;just move as much pixels as have been created
	ret
UpdateDot endp


end start
